import requests

def search(query=None, count=5):
    if query is None:
        raise Exception("Missing required argument: query")

    params = {
        "query": query,
        "count": count
    }
    endpoints = requests.get("https://raw.githubusercontent.com/AnnikaV9/duckduckapi/master/endpoint").text
    for endpoint in endpoints.split("\n"):
        try:
            response = requests.post(endpoint, json=params)
            break
        
        except:
            response = False
    
    if not response:
        raise Exception("None of the DuckDuckAPI public endpoints are available")

    if response.status_code == 200:
        return response.json()["results"]
    
    else:
        try:
            description = response.json()["description"]
        
        except:
            description = "Unknown"
        
        raise Exception("Response status not 200, server returned {} (Description: {})".format(response.status_code, description))
